
 /************************************************************************
  * Copyright 2005-2006 by Freescale Semiconductor, Inc.
  * All modifications are confidential and proprietary information
  * of Freescale Semiconductor, Inc. ALL RIGHTS RESERVED.
  ************************************************************************/

/*******************, AACD_global_struct *ptr*********************************************************
 *
 *   CHANGE HISTORY
 *   dd/mm/yy   Code Ver     Description                        Author
 *   --------   -------      -----------                        ------
 *   14/01/2000  0.01        Prototype changes for              Nanda
 *                           Coldfire.                          Kishore A.S
 *   28/02/2000  0.02        Review changes                     Nanda
 *                                                              Kishore A.S
 *
 *   03/03/2000  0.03        Introduced prototypes of           Bharath
 *                           AACD_decode_huff_cw3(),AACD_find_lead_ones()
 *                           aacd_and AACD_unpack_pkinfo()
 *
 *   08/03/2000  0.04        AACD_freq2time_adapt() interface        B.Venkatarao
 *                           changed
 *   09/03/2000  0.05        Prototypes for new functions       B.Venkatarao
 *                           AACD_intensity_loop() aacd_and 
 *                           AACD_ms_stereo_loop() are added
 *   15/03/2000  0.07        Dequant aacd_and stereo integration     Nanda
 *                           changes                            Kishore A.S
 *   20/03/2000  0.08        TNS integration                    Nanda
 *                           changes                            Kishore A.S
 *   21/03/2000  0.09        normalisation integration          Nanda
 *                           changes                            Kishore A.S
 *   22/03/2000  0.10        Prototype changes for AACD_getescape()  B.Venkatarao
 *                           AACD_decode_huff_cw3() aacd_and
 *                           AACD_unpack_pkinfo()
 *   27/03/2000  0.11        Huffman integration                Nanda
 *                           changes                            Kishore A.S
 *   13/04/2000  0.12        Added prototypes for 
 *                           AACD_decode_init, AACD_decode_info   Nanda
 *                           aacd_and AACD_decode_frame               Kishore A.S
 *   03/05/2000  0.13        Memory design changes              B.Venkatarao
 *   18/07/2003    14        New window-ola design              B.Venkatarao
 *   13/02/2004    15        Modified prototypes for            Vishala
 *                           relocatability
 *   24/05/2004    16        Added function definition for PNS  Pradeep V
 *   08/07/2004    17        Modified proto-type of             S.Nachiappan
 *                           AACD_writeout() 
 *   19/08/2004    20        AACD_decode_info additionally      S.Nachiappan
 *                           receives a pointer to 
 *                           AACPD_Block_Params, which contains
 *                           parameters similar to ADIF/ADTS 
 *                           header data.
 *   23/07/2004    18        Modified the prototype of 
 *                           AACD_writeout, AACD_freq2time_adapt,
 *                           AACD_window_overlap_add aacd_and
 *                           AACD_window_overlap_add_flat to 
 *                           accomudate the 24 bit PCM output    Pradeep V
 *   30/07/2004    19        Added AACD_global_struct parameter
 *                           to AACD_window_overlap_add_flat     Pradeep V
 *   16/09/2004    20        Removed AACD_decode_info() 
 *                           proto-type, as it now returns       S.Nachiappan
 *                           a AACD_RET_TYPE value
 *                           Modified proto-type for pns() 
 *   19/04/2007    21        Added Function memcpy16b_ua         Satish K Singh
 ****************************************************************************/
#ifndef _aac_fix_proto_h_
#define _aac_fix_proto_h_

#include "aacplus_dec_interface.h" 
#include "aac_common.h"

void            AACD_init_globals (void *glblptr, void *tblptr[]);

/*----------------------------------------------------------------------------*
 * aiff_support.h
 *----------------------------------------------------------------------------*/

/*
  AACD_WriteAIFFHeader()

  Writes AIFF header information at head of file *fp,
  aacd_and positions write pointer at audio data.
  Returns 0 if successful, -1 for error.

  NOTE: It is customary to call this TWICE: Once to
  put a placeholder in at the beginning of writing,
  aacd_and again at the end (when #frames is known). The
  size of the header is not dependent on the data.
*/

int
AACD_WriteAIFFHeader(int fd,     /* already opened file descriptor */
    short nChannels,        /* #channels in this file */
    unsigned long nFrames,  /* #sample frames in this file */
    short sampleSize,       /* word size in bits (1-32) */
    unsigned long sampleRate    /* sampling rate */
);

/*----------------------------------------------------------------------------*
 * gc.h
 *----------------------------------------------------------------------------*/

#ifdef  SSR
void
AACD_gain_control(float *freqSigCh,
             Wnd_Shape * wnd_shape,
             int window_sequenceCh,
             int ch,
             float *timeSigCh
            );
#endif
/*----------------------------------------------------------------------------*
 * all.h
 *----------------------------------------------------------------------------*/

    void            AACD_apply_drc(MC_Info *mip, Float *coef, int ch);
    int             AACD_byte_align(void);
    int             AACD_ch_index(MC_Info * mip, int cpe, int tag);
    int             AACD_check_mc_info(MC_Info * mip, int new_config, AACD_global_struct *ptr);
    int             AACD_chn_config(int id, int tag, int common_window,
                               MC_Info * mip, AACD_global_struct *ptr);
    void            AACD_closefiles(MC_Info * mip, AACD_global_struct *ptr);
    void            AACD_clr_tns(Info * info, TNS_frame_info * tns_frame_info);

#if (CChans > 0)
    void            AACD_coupling(Info * info, MC_Info * mip, Float ** coef,
                             Float ** cc_coef, Float * cc_gain[CChans][Chans],
                             int ch, int cc_dom, int cc_ind);

#endif
    int             AACD_dynamic_range_info(void);
    int             AACD_endblock(void);
    int             AACD_enter_chn(int cpe, int tag, char position,
                              int common_window, MC_Info * mip);
    int             AACD_enter_mc_info(MC_Info * mip, AACPD_ProgConfig * pcp, AACD_global_struct *ptr);
    int             AACD_extension_payload(int cnt, byte *data, AACD_global_struct *ptr);
    
    void            AACD_fltclr(Float *dp1, int cnt);
    void            AACD_fltset(Float * dp1, Float dval, int cnt);
    void            AACD_fmtchan(char *p, float *data, int stride);
    int AACD_get_adif_header(AACD_global_struct *ptr);
    int AACD_get_adts_header(AACD_global_struct *ptr);
    int AACD_get_ics_info(byte * win, byte * wshape, byte * group,
                                 byte * max_sfb, int *lpflag, int *prstflag, AACD_global_struct *ptr);
    int AACD_get_prog_config(AACPD_ProgConfig * p, int *ptag, AACD_global_struct *ptr);
    int             AACD_get_tns(Info * info, TNS_frame_info * tns_frame_info, AACD_global_struct *ptr);
  
#if (CChans > 0)
    int             AACD_getcc(MC_Info * mip, byte *cc_wnd, Wnd_Shape *cc_wnd_shape,
                          Float ** cc_coef, Float * cc_gain[CChans][Chans]);

#endif
    int             AACD_getdata(int *tag, int *dt_cnt, byte * data_bytes, AACD_global_struct *ptr);
    int             AACD_getescape(int q, AACD_global_struct *ptr);
    void            AACD_getfill(byte *data, AACD_global_struct *ptr);
    void            AACD_getgroup(Info * info, byte * group, AACD_global_struct *ptr);
    int             AACD_getics(Info * info, int common_window, byte * win,
                           byte * wshape, byte * group, byte * max_sfb,
                           int *lpflag, int *prstflag, byte * cb_map,
                           Lfract * coef_lf, short *global_gain,
                           short *factors, TNS_frame_info * tns,
#ifdef  SSR
                           int ch,
#endif
                           int *norm_shift, AACD_global_struct *ptr);
    int             AACD_getmask(Info * info, byte * group, byte max_sfb,
                            byte * mask, AACD_global_struct *ptr);
    long            AACD_getshort(void);
    void            AACD_huffbookinit(AACD_global_struct *ptr);
    int             AACD_huffcb(byte * sect, int *sectbits, int tot_sfb,
                           int sfb_per_sbk, byte max_sfb, AACD_global_struct *ptr);
    int             AACD_huffdecode(int id, MC_Info * mip, byte * win, 
                               Wnd_Shape * wshape, byte ** cb_map,
                               short **factors, byte ** group,
                               byte * hasmask, byte ** mask, byte * max_sfb,
                               int **lpflag, int **prstflag,
                               TNS_frame_info ** tns, Lfract **coef,
                               int *first, int *last, int *norm_shift, AACD_global_struct *ptr);
    int             AACD_hufffac(byte max_sfb, Info * info, byte * group, int nsect, byte * sect,
                            short global_gain, short *factors, byte *sfb_cb, AACD_global_struct *ptr);

/*    int             AACD_huffspec(byte max_sfb, Info * info, int nsect, byte * sect,
                             short *factors, Lfract * coef_lf, byte *sfb_cb,
                             int * norm_shift);  */

    int             AACD_huffspec(Info * info, int nsect, byte * sect,
                             short *factors, Lfract * coef_lf, byte *sfb_cb,
                             int * norm_shift, AACD_global_struct *ptr); 

#ifdef GENERATE_OLD_HUFFMAN_TABLES
    void            AACD_hufftab(Hcb * hcb, MOT_Huffman * hcw, int dim, int lav,
                            int signed_cb);

#endif
    void            AACD_infoinit(SR_Info * sip, AACD_global_struct *ptr);
    void            AACD_init(AACD_global_struct *ptr);
    void            AACD_init_cc(void);
    void            AACD_init_drc(void);
    void            AACD_init_pred_stat(PRED_STATUS * psp, int grad,
                                   float alpha, float a, float b);
    AACPD_RET_TYPE   AACD_initio(AACD_global_struct *ptr);

#if (CChans > 0)
    void            AACD_ind_coupling(MC_Info * mip, byte * wnd,
                                 Wnd_Shape * wnd_shape, byte * cc_wnd,
                                 Wnd_Shape * cc_wnd_shape,
                                 Float * cc_coef[CChans],
                                 Float * cc_state[CChans]);

#endif
    void            AACD_intcpy(int *ip1, int *ip2, int cnt);
    void            AACD_intensity(MC_Info * mip, Info * info, int widx,
                              int ch, byte * group, byte * cb_map,
                              short *factors, int *lpflag,
                              Lfract **coef_lf, int *norm_shift,
                              AACD_global_struct *ptr);
    void            AACD_intensity_loop (int intensity_norm, int no_intensity_norm,
                                    int nband, Lfract *right, Lfract *left,
                                    byte *cb_map, short *band, short *factors,
                                    AACD_global_struct *ptr);
    void            AACD_lfractclr(Lfract * dp1, int cnt);
    int             main(int argc, char *argv[]);
    void            AACD_map_drc_channels(MC_Info *mip);
    void            AACD_map_mask(Info * info, byte * group, byte * mask,
                             byte * cb_map);
    void            myexit(int errornum, AACD_global_struct *ptr);
    void            AACD_norm_dequant_out (Lfract *mantissa_lf, short *exp,
                                      int count, short max_exp);

    int             AACD_open_output_files(AACPD_Decoder_info *dec_info, MC_Info * mip, AACD_global_struct *ptr);
    int             AACD_pred_max_bands(AACD_global_struct *ptr);
    void            AACD_predict(Info * info, int profile, int *lpflag,
                            PRED_STATUS * psp, Float * coef);
    void            AACD_predict_reset(Info * info, int *prstflag,
                                  PRED_STATUS ** psp, int firstCh, int lastCh);
/*    void            AACD_predinit(void); */
    void            AACD_predinit(AACD_global_struct *ptr);
    void            AACD_print_mc_info(MC_Info *mip);
    void            AACD_reset_drc(void);
    void            AACD_reset_mc_info(MC_Info * mip, AACD_global_struct *ptr);
    void            AACD_reset_pred_state(PRED_STATUS * psp);
    void            AACD_restarttio(void);
    void            AACD_set_drc(int enable, Float hi, Float lo);
    int             AACD_startblock(AACD_global_struct *ptr);
    void            AACD_synt(Info * info, byte * group, byte * mask, Lfract * right,
                         Lfract * left, int *norm_shift_left,
                         int *norm_shift_right);
    void            AACD_ms_stereo_loop_withshift (int shift_right, int shift_left, int nband,
                                    Lfract *right, Lfract *left, byte *mask,
                                    short *band);
    void            AACD_ms_stereo_loop_noshift ( int nband,
                                    Lfract *right, Lfract *left, byte *mask,
                                    short *band);
    void            AACD_scale_spectrum (int *in, int scale, int ss_begin,
                                    int ss_end, Lfract mantissa_lf[],
                                    short exp[], AACD_global_struct *ptr, short max_exp); 
    void            AACD_unpack_idx(int *qp, int idx, Hcb * hcb);
    void            AACD_usage(char *s);

#ifdef  SSR
    void            AACD_unpac_gaincontrol_data(int ch, int window);
#endif

/*----------------------------------------------------------------------------*
 * tns.h
 *----------------------------------------------------------------------------*/
    void            AACD_tns_ar_filter(Lfract * spec, int size, int inc,
                                  Lfract * lpc, int order, Lfract * tns_filt_state);
    int            AACD_tns_decode_coef(int order, int coef_res, short *coef,
                                    Lfract * a, AACD_global_struct *ptr);
    int            AACD_tns_decode_subblock(Lfract * spec_lf, int nbands,
                                        short *sfb_top, int islong,
                                        TNSinfo * tns_info, AACD_global_struct *ptr);
    int             AACD_tns_max_bands(int win, AACD_global_struct *ptr);
    int             AACD_tns_max_order(int islong, AACD_global_struct *ptr);
    void            AACD_print_tns(TNSinfo * tns_info);

/*----------------------------------------------------------------------------*
 * window.h
 *----------------------------------------------------------------------------*/
int  AACD_freq2time_adapt (byte blockType, byte blockTypePrev,
                           Wnd_Shape *wnd_shape, byte *wnd_shape_pre, Lfract *input,
                           AACPD_OutputFmtType *output, Lfract *timeBuff, AACD_global_struct *ptr);
#ifndef ARM_INLINE_ASM_WINDOW
void AACD_window_overlap_add (register AACPD_OutputFmtType *output,
                              register Lfract *curr_imdct,
                              Lfract *prev_imdct, Lfract *wind_ptr,
                              register int len,
                              AACD_global_struct *ptr);
void AACD_window_overlap_add_flat (register AACPD_OutputFmtType *output,
                                   register Lfract *input,
                                   register int len, AACD_global_struct *ptr);
#else
void AACD_window_overlap_add (register AACPD_OutputFmtType *output,
                              register Lfract *curr_imdct,
                              Lfract *prev_imdct, Lfract *wind_ptr,
                              register int len,
                              int num_pcm_bits);
void AACD_window_overlap_add_flat (register AACPD_OutputFmtType *output,
                                   register Lfract *input,
                                   register int len, 
                                   int num_pcm_bits);
#endif

void AACD_window_short_long_illegal (AACPD_OutputFmtType *output, Lfract *curr_imdct,
                                     Lfract *prev_imdct, Lfract *wind_ptr1,
                                     Lfract *wind_ptr2,
                                     int len, AACD_global_struct *ptr);

void AACD_window_stop_illegal (AACPD_OutputFmtType *output, Lfract *curr_imdct,
                               Lfract *prev_imdct, Lfract *wind_ptr1,
                               Lfract *wind_ptr2, int len, AACD_global_struct *ptr);

void AACD_window_long_short_illegal (AACPD_OutputFmtType *output, Lfract *curr_imdct,
                                     Lfract *prev_imdct, Lfract *short_wind_ptr,
                                     Lfract *long_wind_ptr,
                                     int len, AACD_global_struct *ptr);

void AACD_window_short_save (Lfract *output, Lfract *curr_imdct,
                             Lfract *prev_imdct, Lfract *wind_ptr,
                             int len, AACD_global_struct *ptr);

void AACD_window_short_save_1 (AACPD_OutputFmtType *output, Lfract *curr_imdct,
                               Lfract *prev_imdct, Lfract *short_wind_ptr,
                               int len, AACD_global_struct *ptr);

void AACD_window_overlap_add_stop (AACPD_OutputFmtType *output, Lfract *curr_imdct,
                                   Lfract *prev_imdct, Lfract *short_wind_ptr, Lfract *long_wind_ptr, int len, AACD_global_struct *ptr);

/*----------------------------------------------------------------------------*
 * huffman.h
 *----------------------------------------------------------------------------*/

    void            AACD_rewindNbits(int N);
    int             AACD_decode_huff_cw3(int tbl);
    int             AACD_find_lead_ones(int dummy);
    void            AACD_unpack_pkinfo(int *qp, int pkinfo, int tbl);
    void            AACD_get_sign_bits(int *qp, int n);
    void            AACD_huffman_loop (int nsect, byte *sect, int *quant,
                                       short *bands, AACD_global_struct *ptr);


/*----------------------------------------------------------------------------*
 * memfuncs
 *----------------------------------------------------------------------------*/

    int             AACD_CheckEOF(AACD_global_struct *ptr);
    void            AACD_reset_decoder (AACD_global_struct *ptr);

/* Bitstream related prototypes */
int AACD_bs_byte_align(AACD_global_struct *ptr);
void AACD_bs_advance_bits (register int nbits, register AACD_global_struct *ptr);
unsigned long AACD_bs_read_bits (register int nbits, register AACD_global_struct *ptr);


void AACD_bs_readinit(unsigned char *buf, int bytes, AACD_global_struct *ptr);
void AACD_bs_refill_bits (AACD_global_struct *ptr);
int AACD_bs_refill_buffer (register AACD_global_struct *glblptr);




unsigned long AACD_bs_look_bits (register int nbits, register AACD_global_struct *ptr);
void AACD_write_outputs_lri (register short *data_l,
                             register short *data_r,
                             short *outbuf, register int len);

#ifdef EVAL_VERSION
void AACD_UpdateEVParams (long samp_rate, long frame_len, AACD_global_struct *ptr);
#endif

#ifdef MPEG4
int pns( MC_Info *mip,
          Info    *info,
          int      ch,
          byte    *group,
          byte    *cb_map,
          short   *factors,
          int     *lpflag,
          Lfract   *coef[Chans],
	  AACD_global_struct *ptr);
#endif

void memcpy16b_ua(Lfract *dst, Lfract *src, int size);

#endif              /* _aac_fix_proto_h_ */
