
 /************************************************************************
  * Copyright 2005-2006 by Freescale Semiconductor, Inc.
  * All modifications are confidential and proprietary information
  * of Freescale Semiconductor, Inc. ALL RIGHTS RESERVED.
  ************************************************************************/

/*******************************************************************************
 *
 * (C) 2003 MOTOROLA INDIA ELECTRONICS LTD.
 *
 *   CHANGE HISTORY
 *   dd/mm/yy   Code Ver Description                     Author
 *   --------   -------  -----------                     ------
 *   03/07/03   00       File Created.                   B.Venkatarao.
 *   27/03/04   01       Relocatability changes          Vishala
 *   10/07/04   02       Included table sizes            Vishala
 *   18/04/07   03       Added pointer to FFT            Satish K Singh 
 *                       twiddle factor table 
 ******************************************************************************/
#ifndef AACD_TABLES_H
#define AACD_TABLES_H

#define  POW_4BY3_TABLE_SIZE            8192
#define  SCALE_FAC_TABLE_SIZE           5
#define  LEN_SAMP_IDX  4 

#ifndef CONST_AACPD
#define CONST_AACPD const
#endif

typedef struct
{
    int             samp_rate;
    int             nsfb1024;
    short          *SFbands1024;
    int             nsfb128;
    short          *SFbands128;
} SR_Info;
                    
extern CONST_AACPD unsigned int AACD_hufftab_off[13];
extern CONST_AACPD unsigned char AACD_HuffTable1[];
extern CONST_AACPD unsigned char AACD_HuffTable2[];
extern CONST_AACPD unsigned char AACD_HuffTable3[];
extern CONST_AACPD unsigned char AACD_HuffTable4[];
extern CONST_AACPD unsigned char AACD_HuffTable5[];
extern CONST_AACPD unsigned char AACD_HuffTable6[];
extern CONST_AACPD unsigned char AACD_HuffTable7[];
extern CONST_AACPD unsigned char AACD_HuffTable8[];
extern CONST_AACPD unsigned char AACD_HuffTable9[];
extern CONST_AACPD unsigned char AACD_HuffTable10[];
extern CONST_AACPD unsigned char AACD_HuffTableEsc[];
extern CONST_AACPD unsigned char AACD_HuffTableScl[];

extern CONST_AACPD short AACD_sfb_96_1024[];   
extern CONST_AACPD short AACD_sfb_96_128[];   
extern CONST_AACPD short AACD_sfb_64_1024[];   
extern CONST_AACPD short AACD_sfb_64_128[];   
extern CONST_AACPD short AACD_sfb_48_1024[];   
extern CONST_AACPD short AACD_sfb_48_128[];   
extern CONST_AACPD short AACD_sfb_32_1024[];   
extern CONST_AACPD short AACD_sfb_24_1024[];   
extern CONST_AACPD short AACD_sfb_24_128[];   
extern CONST_AACPD short AACD_sfb_16_1024[];   
extern CONST_AACPD short AACD_sfb_16_128[];   
extern CONST_AACPD short AACD_sfb_8_1024[];   
extern CONST_AACPD short AACD_sfb_8_128[];   

extern CONST_AACPD short AACD_bitrev_indices_256[];
extern CONST_AACPD short AACD_bitrev_indices_2048[];

extern CONST_AACPD long int   AACD_scale_fac_table_lf[];
extern CONST_AACPD long int   AACD_k_tab_lf[];
extern CONST_AACPD long int AACD_fft_radix4_twidfac[];
extern CONST_AACPD long int AACD_prepost_twidfac[];
extern CONST_AACPD short AACD_num_bitrev_sets[];
extern CONST_AACPD long int   AACD_pow_4by3_table_lf[POW_4BY3_TABLE_SIZE];
extern CONST_AACPD long int   AACD_scale_fac_table_lf[SCALE_FAC_TABLE_SIZE];

extern CONST_AACPD int      AACD_pred_max_bands_tbl[(1 << LEN_SAMP_IDX)];
extern CONST_AACPD SR_Info  AACD_samp_rate_info[];
extern CONST_AACPD int      AACD_tns_max_bands_tbl[(1 << LEN_SAMP_IDX)][4];
extern CONST_AACPD short    AACD_sgn_mask[];
extern CONST_AACPD unsigned short AACD_neg_mask[];

extern CONST_AACPD long int AACD_window_fhg_short [];
extern CONST_AACPD long int AACD_window_fhg_long [];
extern CONST_AACPD long int AACD_window_dol_short [];
extern CONST_AACPD long int AACD_window_dol_long [];

extern CONST_AACPD unsigned char AACD_n_lzeros_8bit[];

extern CONST_AACPD long int log2_coef[33][4];
extern CONST_AACPD long int pow2_coef[33][4];
extern CONST_AACPD int n_lzeros_8bit[256];
extern CONST_AACPD long int pow2_neg_coef[4];


extern CONST_AACPD long int Coeff_CR_512[];
extern CONST_AACPD long int Coeff_CI_512[];
extern CONST_AACPD long int Coeff_CR_64[];
extern CONST_AACPD long int Coeff_CI_64[];
extern CONST_AACPD long int Coeff_PostTwid_CR_long[];
extern CONST_AACPD long int Coeff_PostTwid_CI_long[];
extern CONST_AACPD long int Coeff_PostTwid_CR_short[];
extern CONST_AACPD long int Coeff_PostTwid_CI_short[];

extern CONST_AACPD Lfract Coeff_FFTTwid_Cos[];


/*******************************************************************************
 * defines for the sizes of all the tables used for aac decoder
 * Note that all the sizes are in bytes
 * ****************************************************************************/
#define AACD_HUFFTAB_OFF_SIZE 13*4         
#define AACD_HUFFSTART_SIZE  13*4          
#define AACD_HUFFTABLE1_SIZE 131  
#define AACD_HUFFTABLE2_SIZE 126  
#define AACD_HUFFTABLE3_SIZE 160  
#define AACD_HUFFTABL4_SIZE 139   
#define AACD_HUFFTABLE5_SIZE 145  
#define AACD_HUFFTABLE6_SIZE 131  
#define AACD_HUFFTABLE7_SIZE 116  
#define AACD_HUFFTABLE8_SIZE 108  
#define AACD_HUFFTABLE9_SIZE 268  
#define AACD_HUFFTABLE10_SIZE 252 
#define AACD_HUFFTABLEESC_SIZE 734  
#define AACD_HUFFTABLESCL_SIZE 224   

#define AACD_SFB_96_1024_SIZE 41*2 
#define AACD_SFB_96_128_SIZE 12*2   
#define AACD_SFB_64_1024_SIZE 47*2  
#define AACD_SFB_64_128_SIZE 12*2      
#define AACD_SFB_48_1024_SIZE 49*2     
#define AACD_SFB_48_128_SIZE 1482       
#define AACD_SFB_32_1024_SIZE 51*2      
#define AACD_SFB_24_1024_SIZE 47*2      
#define AACD_SFB_24_128_SIZE 15*2       
#define AACD_SFB_16_1024_SIZE 43*2     
#define AACD_SFB_16_128_SIZE 15*2       
#define AACD_SFB_8_1024_SIZE 40*2     
#define AACD_SFB_8_128_SIZE 15*2     

#define AACD_BITREV_INDICES_256_SIZE 56*2 
#define AACD_BITREV_INDICES_2048_SIZE 480*2 

#define AACD_SCALE_FAC_TABLE_LF_SIZE 5*4  
#define AACD_K_TAB_LF_SIZE 25*4     
#define AACD_FFT_RADIX4_TWIDFAC_SIZE 6*4  
#define AACD_PREPOST_TWIDFAC_SIZE 12*4    
#define AACD_NUM_BITREV_SETS 2*2 
#define AACD_BITREV_INDICES 2*4   
#define AACD_POW_4BY2_TABLE_LF_SIZE 8192*4   

#define AACD_PRED_MAX_BANDS_TBL_SIZE 16*4  
#define AACD_SAMP_RATE_INFO_SIZE 16*20     
#define AACD_TNS_MAX_BANDS_TBL_SIZE 16*4   
#define AACD_SGN_MASK_SIZE 3*2    
#define AACD_NEG_MASK_SIZE 3*2    
#define AACD_WINDOW_FHG_SHORT_SIZE 128*4  
#define AACD_WINDOW_FHG_LONG_SIZE 1024*4  
#define AACD_WINDOW_DOL_SHORT_SIZE 128*4  
#define AACD_WINDOW_DOL_LONG_SIZE 1024*4   

#define AACD_WINDOWPTR_SIZE 4*4   
#define AACD_N_LZEROS_8BIT_SIZE 256   

#define LOG2_COEF_SIZE 33*4*4      
#define POW2_COEF_SIZE 33*4*4        
#define POW2_NEG_COEF_SIZE 4*4    


#define COEFF_CR_512_SIZE 512*4   
#define COEFF_CI_512_SIZE 512*4    
#define COEFF_CR_64_SIZE 64*4     
#define COEFF_CI_64_SIZE 64*4     
#define COEFF_POSTTWID_CR_LONG_SIZE 257*4  
#define COEFF_POSTTWID_CI_LONG_SIZE 257*4  
#define COEFF_POSTTWID_CR_SHORT_SIZE 34*4  
#define COEFF_POSTTWID_CI_SHORT_SIZE 33*4   
#define COEFF_FFTTWID_COS_SIZE 263*4 

#endif
